// SelWinTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SelWinTest.h"
#include "SelWinTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelWinTestDlg dialog

CSelWinTestDlg::CSelWinTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSelWinTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelWinTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSelWinTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelWinTestDlg)
	DDX_Control(pDX, IDC_LIST1, m_ListInfo);
	DDX_Control(pDX, IDC_BRCSELWINCTRL1, m_SelWin);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSelWinTestDlg, CDialog)
	//{{AFX_MSG_MAP(CSelWinTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_CMD_LOAD, OnCmdLoad)
	ON_BN_CLICKED(IDC_RADIO_TYPE, OnRadioType)
	ON_BN_CLICKED(IDC_RADIO_TYPE2, OnRadioType2)
	ON_BN_CLICKED(IDC_RADIO_TYPE3, OnRadioType3)
	ON_BN_CLICKED(IDC_BROWSE2, OnBrowse2)
	ON_BN_CLICKED(IDC_CMD_ADDBUTTON, OnCmdAddButton)
	ON_BN_CLICKED(IDC_CMD_CLEAR, OnCmdClear)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelWinTestDlg message handlers

BOOL CSelWinTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
  CButton* pRadio = (CButton*)GetDlgItem(IDC_RADIO_TYPE);
  pRadio->SetCheck(1);

  m_SelWin.SetBarType(0);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSelWinTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSelWinTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CSelWinTestDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CSelWinTestDlg)
	ON_EVENT(CSelWinTestDlg, IDC_BRCSELWINCTRL1, 1 /* ButtonClick */, OnButtonClickBrcselwinctrl1, VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CSelWinTestDlg::OnButtonClickBrcselwinctrl1(long nIndex) 
{

  Beep(1000, 100);
  
  CString strTemp;
  strTemp.Format(": OnButtonClick(%d)", nIndex);
  m_ListInfo.InsertString(0, strTemp);
	
}

void CSelWinTestDlg::OnBrowse()
{

  CString strTemp, strPath;

  CFileDialog dlg(TRUE, NULL, strTemp, 0, "BRC Configurator Files (*.cfg)|*.cfg|");
  if ( dlg.DoModal() != IDOK )
    return;

  strPath = dlg.GetPathName();

  

  //     ComboBox
  BOOL bFound = FALSE;
  long i, nCount;

  CComboBox* pBox = (CComboBox*)GetDlgItem(IDC_COMBO1);
  nCount = pBox->GetCount();

  for ( i=0; i<nCount; i++ )
  {
    pBox->GetLBText(i, strTemp);
    if ( strPath == strTemp )
    {
      bFound = TRUE;
      pBox->SetCurSel(i);
      break;
    }
  }

  if ( !bFound )
    pBox->SetWindowText(strPath);
  
}

void CSelWinTestDlg::OnCmdLoad() 
{

  CString strPath, strTemp;

  m_ListInfo.InsertString(0, "OnCmdLoadBegin");

  //     ComboBox
  BOOL bFound = FALSE;
  long i, nCount, nRes;

  CComboBox* pBox = (CComboBox*)GetDlgItem(IDC_COMBO1);
  pBox->GetWindowText(strPath);
  nCount = pBox->GetCount();

  for ( i=0; i<nCount; i++ )
  {
    pBox->GetLBText(i, strTemp);
    if ( strPath == strTemp )
    {
      bFound = TRUE;
      pBox->SetCurSel(i);
      break;
    }
  }
  

  nRes = m_SelWin.LoadConfig(strPath);
  if ( nRes < 0 )
  {
    m_ListInfo.InsertString(0, "  ");
    return;
  }


  if ( !bFound )
  {
    pBox->SetCurSel(pBox->AddString(strPath));
  }
	
  m_ListInfo.InsertString(0, "OnCmdLoadEnd");

}

void CSelWinTestDlg::OnRadioType() 
{

  // NORMAL
  m_SelWin.SetBarType(0);
	
}

void CSelWinTestDlg::OnRadioType2() 
{

  // RADIO
  m_SelWin.SetBarType(1);
	
}

void CSelWinTestDlg::OnRadioType3() 
{

  // CHECKABLE
  m_SelWin.SetBarType(2);
	
}

void CSelWinTestDlg::OnBrowse2() 
{

  CString strTemp, strPath;

  CFileDialog dlg(TRUE, NULL, strTemp, 0, "Bitmap files (*.bmp)|*.bmp|");
  if ( dlg.DoModal() != IDOK )
    return;

  strPath = dlg.GetPathName();

  

  //     ComboBox
  BOOL bFound = FALSE;
  long i, nCount;

  CComboBox* pBox = (CComboBox*)GetDlgItem(IDC_COMBO2);
  nCount = pBox->GetCount();

  for ( i=0; i<nCount; i++ )
  {
    pBox->GetLBText(i, strTemp);
    if ( strPath == strTemp )
    {
      bFound = TRUE;
      pBox->SetCurSel(i);
      break;
    }
  }

  if ( !bFound )
    pBox->SetWindowText(strPath);

}

void CSelWinTestDlg::OnCmdAddButton() 
{

  CString strPath, strTemp, strCaption;

  m_ListInfo.InsertString(0, "OnCmdAddButtonBegin");

  //     ComboBox
  BOOL bFound = FALSE;
  long i, nCount, nRes;

  CComboBox* pBox = (CComboBox*)GetDlgItem(IDC_COMBO2);
  pBox->GetWindowText(strPath);
  nCount = pBox->GetCount();

  for ( i=0; i<nCount; i++ )
  {
    pBox->GetLBText(i, strTemp);
    if ( strPath == strTemp )
    {
      bFound = TRUE;
      pBox->SetCurSel(i);
      break;
    }
  }
  

  CEdit* pEdit = (CEdit*)GetDlgItem(IDC_EDIT_CAPTION);
  pEdit->GetWindowText(strCaption);

  nRes = m_SelWin.AddButton(strCaption, strPath);
  if ( nRes < 0 )
  {
    m_ListInfo.InsertString(0, " AddButton");
    return;
  }


  if ( !bFound )
  {
    pBox->SetCurSel(pBox->AddString(strPath));
  }
	
  m_ListInfo.InsertString(0, "OnCmdAddButtonEnd");
  	
}

void CSelWinTestDlg::OnCmdClear() 
{

  m_SelWin.Clear();
	
}
